<?php
/**
 * Created by PhpStorm.
 * User: zilongs
 * Date: 20-9-23
 * Time: 上午11:36
 */

namespace App\Http\Controllers\Api\V1;

use App\Models\User;
use EasyWeChat\Factory;

class UserController extends AuthController
{
    public function userInfo()
    {
        $user = $this->user;

        unset($user['session_key']);

        return out($user);
    }

    public function getPhoneNumber()
    {
        $req = request()->post();
        $this->validate(request(), [
            'iv' => 'required',
            'encryptData' => 'required',
        ]);
        $user = $this->user;

        $app = Factory::miniProgram(config('config.wechat_small_program'));

        try {
            $decryptedData = $app->encryptor->decryptData($user['session_key'], $req['iv'], $req['encryptData']);
        } catch (\Exception $e) {
            return out(null, 10001, '获取手机号失败', $e->getMessage());
        }

        return out($decryptedData);
    }

    public function updateUser()
    {
        $req = request()->post();
        $this->validate(request(), [
            'nickname' => 'max:100',
            'avatar' => 'url',
            'sex' => 'in:1,2',
            'birthday' => 'date',
            'latitude' => 'numeric',
            'longitude' => 'numeric',
        ]);
        $user = $this->user;

        User::where('id', $user['id'])->update($req);

        return out();
    }
}
